Bug 226993 - java/java3d: fails to link with lld as the system linker
Summary: java/java3d: fails to link with lld as the system linker
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: freebsd-ports-bugs mailing list
URL:
Keywords:
Depends on:
Blocks: 214864
  Show dependency treegraph
 
Reported: 2018-03-27 16:14 UTC by Ed Maste
Modified: 2018-03-29 10:34 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ed Maste freebsd_committer 2018-03-27 16:14:05 UTC
I'm working on switching to LLVM's lld linker as the FreeBSD system linker (/usr/bin/ld)[1], and the port in this PR is reported as a new failure in the exp-run, PR 214864.

An excerpt from the build log[2]:
---
install  -m 0644  /wrkdirs/usr/ports/java/java3d/work/java3d-1.5.2/vecmath/dist/lib/ext/vecmath.jar  /wrkdirs/usr/ports/java/java3d/work/java3d-1.5.2/j3d-core/build/default/opt/lib/ext/j3dcore.jar  /wrkdirs/usr/ports/java/java3d/work/java3d-1.5.2/j3d-core/build/default/opt/lib/ext/j3dutils.jar  /wrkdirs/usr/ports/java/java3d/work/stage/usr/local/openjdk8/jre/lib/ext
install  /wrkdirs/usr/ports/java/java3d/work/java3d-1.5.2/j3d-core/build/default/opt/native/libj3dcore-ogl.so  /wrkdirs/usr/ports/java/java3d/work/stage/usr/local/openjdk8/jre/lib/amd64
install: /wrkdirs/usr/ports/java/java3d/work/java3d-1.5.2/j3d-core/build/default/opt/native/libj3dcore-ogl.so: No such file or directory
*** Error code 71
---

More investigation is needed - it is not clear in the log why libj3dcore-ogl.so failed to build.

FreeBSD 11 and later have lld available as /usr/bin/ld.lld, so one simple option for testing is to just symlink /usr/bin/ld to ld.lld (and restore it to ld.bfd).

A port Makefile knob, LLD_UNSAFE=yes, exists to indicate that a port does not work with lld, and requires either /usr/bin/ld.bfd or binutils from ports. This should work for the common case of ports written in C using GNU autoconf; it may have no effect on other ports.

[1] https://lists.freebsd.org/pipermail/freebsd-current/2018-March/068985.html
[2] http://package18.nyi.freebsd.org/data/headamd64PR214864-default/2018-03-21_17h43m11s/logs/errors/java3d-1.5.2_5.log
Comment 1 Ed Maste freebsd_committer 2018-03-27 20:48:55 UTC
Via tobik@ in ports r465725, BINARY_ALIAS=ld=ld.bfd may be an effective workaround if LLD_UNSAFE does not work.
Comment 2 commit-hook freebsd_committer 2018-03-29 10:34:35 UTC
A commit references this bug:

Author: krion
Date: Thu Mar 29 10:33:46 UTC 2018
New revision: 465879
URL: https://svnweb.freebsd.org/changeset/ports/465879

Log:
  Switch to ld.bfd by default as ld.ldd doesn't have built-in default
  output target.

  PR:		226993
  Submitted by:	emaste
  Approved by:	portmgr (LLD_UNSAFE blanket)

Changes:
  head/java/java3d/Makefile